<?php
class CTextQuestionAccess extends CTblAccess {
//ƥȤȤɽ뤿Υ饹
	function CTextQuestionAccess () {
		$this->CTblAccess (QUES_TBL." AS que, ".TXT_TBL." AS txt");
	}

	function getQuestionDataPerTest($conn, $text_id) {
		$want_col = "txt.text_title, que.question_id, que.exp_dif, que.real_dif, ";
		$want_col .= "que.level, que.content, que.teacher_id, ";
		$want_col .= "que.registered_date, que.comment, que.answer, que.example ";
		$condition = " WHERE text_id = '".$this->escapeSqlString($text_id);
		$condition .= "' ORDER BY txt.text_title, que.registered_date";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
	
	function getQuestionDataWithTxt($conn, $qid) {
		$want_col = "txt.text_title, que.question_id, que.exp_dif, que.real_dif, ";
		$want_col .= "que.level, que.content, que.teacher_id, ";
		$want_col .= "que.registered_date, que.comment, que.answer, que.example ";
		$condition = " WHERE txt.text_id = que.text_id AND que.question_id = '".$this->escapeSqlString($qid);
		$condition .= "' ORDER BY txt.text_title, que.registered_date";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		}
		return $result;
	}
}

class CTestInClassAccess extends CTblAccess {
	//ŪʰĤΥƥȤԤݤΥ饹
	//褯ƤӽФơ֥ĤˤޤȤ
	//³ζͭͤ¾Ȱ㤦åˤ
	//ͤơϤ褦ˤ

	function CTestInClassAccess() {
		$this->CTblAccess ("NOT IDENTIFIED");
	}
	
	function getGeneralInfo($conn,$test_id) {
	//饹ƥȤΰ̾ʶ̾ID饹̾饹IDƥ̾ˤ
		//ʣơ֥
//		$this->tbl_name = TEA_TBL." AS tt, ".CLASS_TBL." AS ct, ".TEST_INF_TBL." AS tit";
//ForXoops
		$this->tbl_name = USER_TBL." AS ut, ".CLASS_TEA_TBL." AS ctt, ".CLASS_TBL." AS ct, ".TEST_INF_TBL." AS tit";

		//ɬץեɤΤƤ
//		$want_col = "tt.teacher_id, tt.teacher_nam, ct.class_id, ct.class_nam, tit.test_nam";
		$want_col = "ut.uid as teacher_id, ut.uname AS teacher_nam, ct.groupid AS class_id, ct.name as class_nam, tit.test_nam";

		$condition = " WHERE ";
//		$condition .= " tit.class_id = ct.class_id AND ctt.teacher_id = tit.teacher_id AND";
		$condition .= " tit.groupid = ct.groupid AND ctt.groupid = tit.groupid AND ctt.uid=ut.uid AND ";
		$condition .= " tit.test_id ='".$this->escapeSqlString($test_id)."'";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}
	
	function getTextAndQuestions($conn,$test_id) {
		//ʣơ֥
		$this->tbl_name = TEST_QUE_TBL." AS tqt, ".TXT_TBL." AS ttb, ".QUES_TBL." AS qt";
		//ɬפʥեɤ
		//2007/1/4եɥХåؤλȤ󤷤θơեɤä
		$want_col ="ttb.text_title, ttb.content AS text_content, ttb.text_id, qt.content AS qt_content,";
		$want_col .= "qt.question_id, tqt.tested_id, qt.answer, tqt.question_order,tqt.score, ";
		$want_col .= "qt.rep_key, qt.max_length, qt.max_words, qt.question_repeat,qt.example,";
		$want_col .= "ttb.av_file, ttb.av_repeat, qt.question_av_file, ttb.img_file ";
		//Whereλ
		$condition = " WHERE ";
		$condition .= "tqt.question_type = qt.question_id AND ";
		$condition .= "qt.text_id = ttb.text_id AND ";
		$condition .= "tqt.test_id = '".$this->escapeSqlString($test_id)."'";
		$condition .= " ORDER BY question_order, text_id";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getSheetOfStudent($conn, $student_id) {
	//ּԤºݤ˼ƥȤΥեǡ

		//ʣơ֥
		$this->tbl_name = CLASS_SU_TBL." AS cst, ";
		$this->tbl_name .= CLASS_TBL." AS cit, ";
		$this->tbl_name .= QUES_TBL." AS qtbl, ";
		$this->tbl_name .= TEST_INF_TBL." AS tit, ".TXT_TBL." AS ttt, ";
		$this->tbl_name .= TEST_QUE_TBL." AS tqt";

		//ɬפʥեɤ
//Xoops
//		$want_col = "cst.class_student_id, cit.class_id, tqt.test_id,";
		$want_col = "cst.class_student_id, cit.groupid as class_id, tqt.test_id,";
//		$want_col .= "tit.test_nam, cit.class_nam, ttt.text_title, ttt.text_id, ";
		$want_col .= "tit.test_nam, cit.name as class_nam, ttt.text_title, ttt.text_id, ";

		$want_col .= "ttt.content AS txt_content, qtbl.question_id, ";
		$want_col .= "qtbl.rep_key, qtbl.max_length, qtbl.max_words, ";
		$want_col .= "tqt.question_order, qtbl.content AS ";
		$want_col .= "que_content, qtbl.answer, tqt.tested_id ";
		$want_col .= ",ttt.av_file, qtbl.question_av_file, ttt.img_file ";
		$want_col .= ",ttt.av_repeat, qtbl.question_repeat ";
		//whereλ
		$condition = " WHERE ";
		$condition .= "qtbl.question_id = tqt.question_type ";
		$condition .= "AND qtbl.text_id = ttt.text_id AND ";
		$condition .= "tqt.test_id = tit.test_id ";
//xoops
//		$condition .= "AND tit.class_id = cst.class_id AND ";
		$condition .= "AND tit.groupid = cst.groupid AND ";


//		$condition .= "cit.class_id = cst.class_id AND cst.present = 1 AND tit.status = 1 ";
//2006/12/20
//		$condition .= "cit.class_id = cst.class_id AND ((cst.present = 1 AND tit.status = 1) OR (cst.present = 4 AND tit.status = 3))";
		$condition .= "cit.groupid = cst.groupid AND ((cst.present = 1 AND tit.status = 1) OR (cst.present = 4 AND tit.status = 3))";

//		$condition .= "AND cst.student_id = '".$this->escapeSqlString($student_id)."'";
		$condition .= "AND cst.uid = '".$this->escapeSqlString($student_id)."'";
		$condition .= " ORDER BY tqt.question_order, ttt.text_id";
		
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getItemOfQuestion($conn, $q_id) {
		$this->tbl_name = ITEM_TBL;
		$condition = " WHERE question_id = '".$this->escapeSqlString($q_id)."' ORDER BY item_order ";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getAnsweredTxtOfStudent($conn, $test_id, $cl_student_id) {
		$this->tbl_name = TEST_QUE_TBL." AS tqt, ".ANSWERED_TXT_TBL." AS att";
		$want_col = "tqt.score, att.answered_txt ";
		$condition =" WHERE tqt.test_id ='".$this->escapeSqlString($test_id)."' AND ";
		$condition .=" att.class_student_id ='".$this->escapeSqlString($cl_student_id)."'";
		$condition .=" AND tqt.tested_id = att.tested_id ORDER BY tqt.question_order";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getAnsweredItemOfStudent($conn, $test_id, $cl_student_id) {
		$this->tbl_name = TEST_QUE_TBL." AS tqt, ".ANSWERED_ITEM_TBL." AS ait";
		$want_col = "tqt.score, ait.answered_item ";
		$condition =" WHERE tqt.test_id ='".$this->escapeSqlString($test_id)."' AND ";
		$condition .=" ait.class_student_id ='".$this->escapeSqlString($cl_student_id)."'";
		$condition .=" AND tqt.tested_id = ait.tested_id ORDER BY tqt.question_order";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
}

class CSetQuestionInClass extends CTestInClassAccess {
//̤ΥƥѤꤹݤѤ

	function getUseableQuestions ($conn, $id_list,$is_rev) {
		
		//idΥꥹȤꡢ˸äǡ֤
		$return_arr = array();

		//ʣơ֥
		$this->tbl_name = QUES_TBL." AS qt, ".TXT_TBL." AS tt";
		//ۤ		
		$want_col = "tt.text_title, qt.content, qt.question_id, qt.text_id, qt.rep_key";

		$condition = " WHERE qt.text_id = tt.text_id";
		$sql_plus="";
		if ($id_list <> "ALL") {
			if ($is_rev == true) {
				for ($i = 0;$i<count($id_list);$i++) {
					if ($i == 0) {
						$sql_plus .= "question_id != '".$this->escapeSqlString ($id_list[0])."'";
					} else {
						$sql_plus .= " AND question_id != '".$this->escapeSqlString ($id_list[$i])."'";					
					}
				}
			} else {
				for ($i = 0;$i<count($id_list);$i++) {
					if ($i == 0) {
						$sql_plus .= "question_id = '".$this->escapeSqlString ($id_list[0])."'";
					} else {
						$sql_plus .= " OR question_id = '".$this->escapeSqlString ($id_list[$i])."'";					
					}
				}			
			}
		}
		if ($sql_plus <> "") {
			$condition = $condition." AND (".$sql_plus.")";
		}
		$condition .= " ORDER BY text_id";

		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getUseableQuestionsWithCond ($conn, $id_list, $search_txt, $dep_id) {
		
		//idΥꥹȤꡢ˸äǡ֤(ʹߤĤ
		$return_arr = array();

		//ʣơ֥
		$this->tbl_name = QUES_TBL." AS qt, ".TXT_TBL." AS tt";
		//ۤ		
		$want_col = "tt.text_title, qt.content, qt.question_id, qt.text_id, qt.rep_key";

		$condition = " WHERE qt.text_id = tt.text_id";
		$sql_plus="";
		if (count($id_list) > 0) {
			for ($i = 0; $i<count($id_list); $i++) {
				if ($i == 0) {
					$sql_plus .= "question_id != '".$this->escapeSqlString ($id_list[0])."'";
				} else {
					$sql_plus .= " AND question_id != '".$this->escapeSqlString ($id_list[$i])."'";				
				}
			}
		}
		if ($sql_plus <> "") {
			$condition = $condition." AND (".$sql_plus.")";
		}
		if ($search_txt <> "") {
			$condition .=" AND tt.text_title LIKE '%".$this->escapeSqlString($search_txt)."%'";
		}
		if ($dep_id <> "" && $dep_id <> 0) {
			$condition .=" AND tt.department_id ='".$this->escapeSqlString($dep_id)."'";
		}

		$condition .= " ORDER BY text_id";

		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	
	function setQuestionsForTest ($conn, $dat_arr) {
//ꤹؿ
		$tested_question_object = new CTestedQuestionTableAccess();
		for ($i=0; $i <$dat_arr['all_cnt']; $i++) {
			//if ($dat_arr['UP'.$i] <> "" &&  $dat_arr['UP'.$i] <> null) {
			if (array_key_exists('UP'.$i, $dat_arr) == true) {
				if (!$tested_question_object->insertQuestionOfTestExe($conn, $this->escapeSqlString($dat_arr['test_id']), $this->escapeSqlString($dat_arr['UP'.$i]))) {
					return false;
				}
			}
		}
		return true;
	}

	function removeQuestionForTest ($conn, $dat_arr) {
//ؿ
		//$tested_question_object = new CTestedQuestionTableAccess();
		$this->tbl_name = TEST_QUE_TBL;
		for ($i=0; $i <$dat_arr['all_cnt']; $i++) {
			//if ($dat_arr['DEL'.$i] <> "" && $dat_arr['DEL'.$i] <> null) {
			if (array_key_exists('DEL'.$i, $dat_arr) == true) {
				$cond = "tested_id = '".$this->escapeSqlString($dat_arr['DEL'.$i])."'";
				if (!$this->delDat($cond, $conn)) {
					return false;
				}
			}
		}
		return true;
	}
	
	function setQuestionOrder($conn, $dat_arr) {
		$full_score = 0;
		$this->tbl_name = TEST_QUE_TBL;
		for ($i=0; $i < $dat_arr['data_cnt'];$i++) {
			$up_set = "question_order = '".$this->escapeSqlString($dat_arr['order'.$i])."'";
			$up_set .= ", score = '".$this->escapeSqlString($dat_arr['score'.$i])."'";
			$where_st = "tested_id = '".$this->escapeSqlString($dat_arr['tested_id'.$i])."'";
			$full_score = $full_score + $dat_arr['score'.$i];
			if (!$this->upDat($up_set, $where_st, $conn)) {
				return false;
			}
		}
		if (!$this->setFullScore($conn, $dat_arr['test_id'], $full_score)) {
			return false;
		}
		return true;
	}
	function setFullScore($conn, $test_id, $full_score) {
	//ꤹ
		$this->tbl_name = TEST_INF_TBL;
		$up_set = "full_score = '".$this->escapeSqlString($full_score)."'";
		$where_st = "test_id = '".$this->escapeSqlString($test_id)."'";
		if (!$this->upDat($up_set, $where_st, $conn)) {
			return false;
		}
		return true;
	}
}

class CTestEvaluateAccess extends CTestInClassAccess {
//κݤθ̷̤ɽ
//2007/1/4ˤϡեɥХåˤ
	function getRightItem ($conn, $question_id) {
//ξ
		$this->tbl_name = ITEM_TBL;
		$condition = " WHERE question_id = '".$this->escapeSqlString($question_id)."'";
		$condition .= " AND is_right = 1 ORDER BY item_order";
		
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
	function getKeyWord($conn, $question_id) {
//䤴ȤΥɤμ
		$this->tbl_name = KEY_WORD_TBL;
		$condition= " WHERE question_id = '".$this->escapeSqlString($question_id)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
	function getAnsweredTxt ($conn,$tested_id, $cl_student_id) {
//줿ƥȤμ
		$this->tbl_name = ANSWERED_TXT_TBL;
		$condition= " WHERE tested_id = '".$this->escapeSqlString($tested_id)."' AND class_student_id = '".$this->escapeSqlString($cl_student_id)."'";
		$result = $this->getList("answered_txt", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
	function getAnsweredItem ($conn, $tested_id, $cl_student_id) {
//줿μ
		$this->tbl_name = ANSWERED_ITEM_TBL;
		$condition = " WHERE tested_id = '".$this->escapeSqlString($tested_id)."' AND class_student_id = '".$this->escapeSqlString($cl_student_id)."'";
		$condition .= " ORDER BY answered_item";
		$result = $this->getList("answered_item", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
}

class CAnalyzeTestClassAccess extends CTblAccess {
//饹ΥƥȷʬѤΥ饹
	function CAnalyzeTestClassAccess() {
		$this->CTblAccess ("NOT IDENTIFIED");
	}

	function getScoreListOfStudents ($conn, $class_id, $test_id) {
		$this->tbl_name = STU_TBL." AS st, ".CLASS_SU_TBL." AS cst, ";
		$this->tbl_name .= STUDENT_TEST_TBL." AS stt, ".ANSWERED_SCORE_TBL." AS ast, ";
		$this->tbl_name .= TEST_QUE_TBL." AS tqt, ".TEST_INF_TBL." AS tit";

		//ɬפʥե
//		$want_col = "st.student_id, student_nam, stt.score AS total_score, stt.sd_score AS total_sd_score, ast.score AS item_score, tit.full_score";
//xoops
		$want_col = "st.uid as student_id, st.uname as student_nam, stt.score AS total_score, stt.sd_score AS total_sd_score, ast.score AS item_score, tit.full_score";
		//
//		$condition = " WHERE st.student_id = cst.student_id AND cst.class_student_id = stt.class_student_id ";
		$condition = " WHERE st.uid = cst.uid AND cst.class_student_id = stt.class_student_id ";
		$condition .= " AND tqt.tested_id = ast.tested_id AND stt.test_id = tqt.test_id ";

//		$condition .= "AND cst.class_student_id = ast.class_student_id AND cst.class_id = '".$this->escapeSqlString($class_id);
		$condition .= "AND cst.class_student_id = ast.class_student_id AND cst.groupid = '".$this->escapeSqlString($class_id);
		$condition .= "' AND stt.test_id = tit.test_id";
//		$condition .= " AND stt.test_id = '".$this->escapeSqlString($test_id)."' ORDER BY student_id, question_order";
		$condition .= " AND stt.test_id = '".$this->escapeSqlString($test_id)."' ORDER BY st.uid, question_order";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getListOfStudents ($conn, $class_id, $test_id) {
//ºݤβΥꥹȤ
		$this->tbl_name = STU_TBL." AS st, ".CLASS_SU_TBL." AS cst, ";
		$this->tbl_name .= STUDENT_TEST_TBL." AS stt, ".ANSWERED_SCORE_TBL." AS ast, ";
		$this->tbl_name .= TEST_QUE_TBL." AS tqt, ".TEST_INF_TBL." AS tit, ".QUES_TBL." AS qt";

		//ɬפʥե
//xoops
//		$want_col = "st.student_id, student_nam, stt.score AS total_score, stt.sd_score AS total_sd_score, ast.score AS item_score, tit.full_score, tqt.tested_id, cst.class_student_id, qt.answer, qt.question_id";
		$want_col = "st.uid as student_id, st.uname as student_nam, stt.score AS total_score, stt.sd_score AS total_sd_score, ast.score AS item_score, tit.full_score, tqt.tested_id, cst.class_student_id, qt.answer, qt.question_id";
		//
//		$condition = " WHERE st.student_id = cst.student_id AND cst.class_student_id = stt.class_student_id ";
		$condition = " WHERE st.uid = cst.uid AND cst.class_student_id = stt.class_student_id ";
		$condition .= " AND tqt.tested_id = ast.tested_id AND stt.test_id = tqt.test_id ";
//		$condition .= "AND cst.class_student_id = ast.class_student_id AND cst.class_id = '".$this->escapeSqlString($class_id);
		$condition .= "AND cst.class_student_id = ast.class_student_id AND cst.groupid = '".$this->escapeSqlString($class_id);

		$condition .= "' AND stt.test_id = tit.test_id AND tqt.question_type = qt.question_id";
//		$condition .= " AND stt.test_id = '".$this->escapeSqlString($test_id)."' ORDER BY student_id, question_order";
		$condition .= " AND stt.test_id = '".$this->escapeSqlString($test_id)."' ORDER BY st.uid, question_order";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}	
	}
	function getAnsweredTxt ($conn,$tested_id, $cl_student_id) {
//줿ƥȤμ
		$this->tbl_name = ANSWERED_TXT_TBL;
		$condition= " WHERE tested_id = '".$this->escapeSqlString($tested_id)."' AND class_student_id = '".$this->escapeSqlString($cl_student_id)."'";
		$result = $this->getList("answered_txt", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
	function getAnsweredItem ($conn, $tested_id, $cl_student_id) {
//줿μ
		$this->tbl_name = ANSWERED_ITEM_TBL;
		$condition = " WHERE tested_id = '".$this->escapeSqlString($tested_id)."' AND class_student_id = '".$this->escapeSqlString($cl_student_id)."'";
		$condition .= " ORDER BY answered_item";
		$result = $this->getList("answered_item", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getItemOfQuestion ($conn, $question_id) {
		$return_arr = array();
		$this->tbl_name = ITEM_TBL;
		$condition = " WHERE question_id = '".$this->escapeSqlString($question_id)."'";
		$result = $this->getList("item_order", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			foreach($result as $item_child) {
				array_push($return_arr, $item_child['item_order']);
			}
			return $return_arr;
		}
	}
}

class CTestResultForClassStudent extends CTblAccess {
//ּ¦鸫Ӿ
	function CTestResultForClassStudent() {
		$this->CTblAccess ("NOT IDENTIFIED");
	}

	function getTestListOfClass ($conn, $class_student_id, $student_id) {
//ƥȤΰ
//class_student_idΤߤǲǽ⤫ͤơ
//student_idåԤ
//xoops
//		$this->tbl_name = TEA_TBL." AS tt, ".CLASS_TBL." AS cit, ";
		$this->tbl_name = CLASS_TEA_TBL." AS ctt, ".USER_TBL." AS tt, ".CLASS_TBL." AS cit, ";

		$this->tbl_name .= TEST_INF_TBL." AS tit, ".CLASS_SU_TBL." AS cst, ";
		$this->tbl_name .= TEST_QUE_TBL." AS tqt ";

		//ɬפʥե
//		$want_col = "tt.teacher_nam, cit.class_nam, tit.test_id,";
		$want_col = "tt.uname as teacher_nam, cit.name as class_nam, tit.test_id,";
		$want_col .= "tit.test_nam, tit.test_date, tit.real_score,";
		$want_col .= "tit.partici_num,tit.status,tit.sd_score, ";
		$want_col .= "sum(tqt.score) AS total_score, cst.groupid AS class_id";

		//ɬפʥեxoops
//		$condition = " WHERE tt.teacher_id = cit.teacher_id AND ";
		$condition = " WHERE ctt.uid = tt.uid AND ctt.groupid = cit.groupid AND ";
//		$condition .= " cit.class_id = tit.class_id AND ";
//		$condition .= " cst.class_id = cit.class_id AND ";
		$condition .= " cit.groupid = tit.groupid AND ";
		$condition .= " cst.groupid = cit.groupid AND ";
		$condition .= "cst.class_student_id = '".$this->escapeSqlString($class_student_id);
//		$condition .= "' AND cst.student_id = '".$this->escapeSqlString($student_id)."'";
		$condition .= "' AND cst.uid = '".$this->escapeSqlString($student_id)."'";

		$condition .= " AND tit.test_id = tqt.test_id ";
//		$condition .= " GROUP BY tit.test_id, tt.teacher_nam, cit.class_nam, ";
		$condition .= " GROUP BY tit.test_id, tt.uname, cit.name, ";

		$condition .= "tit.test_nam, tit.test_date, tit.real_score, ";
		$condition .= "tit.partici_num,tit.status,tit.sd_score ORDER BY test_date";

		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getDetailScoreOfStudent ($conn, $test_id, $class_student_id, $student_id) {
//		$this->tbl_name = TEA_TBL." AS tt, ".CLASS_TBL." AS cit, ".TEST_INF_TBL." AS tit, ";

		$this->tbl_name = CLASS_TEA_TBL." AS ctt, ".USER_TBL." AS tt, ".CLASS_TBL." AS cit, ".TEST_INF_TBL." AS tit, ";

		$this->tbl_name .= STU_TBL." AS st, ".CLASS_SU_TBL." AS cst, ";
		$this->tbl_name .= STUDENT_TEST_TBL." AS stt, ".ANSWERED_SCORE_TBL." AS ast, ";
		$this->tbl_name .= TEST_QUE_TBL." AS tqt, ".QUES_TBL." AS qt ";

		//ɬפʥե
//		$want_col = "st.student_id, student_nam, stt.score AS total_score, stt.sd_score AS total_sd_score, ast.score AS item_score,";
		$want_col = "st.uid as student_id, st.uname as student_nam, stt.score AS total_score, stt.sd_score AS total_sd_score, ast.score AS item_score,";
		$want_col .= "stt.st_ts_comment, stt.tea_ts_comment, qt.content, qt.example, ";

//		$want_col .= "tt.teacher_nam, cit.class_nam, tit.test_id,";
		$want_col .= "tt.uname as teacher_nam, cit.name as class_nam, tit.test_id,";

		$want_col .= "tit.test_nam, tit.test_date, tit.real_score,";
//		$want_col .= "tit.partici_num,tit.status,tit.sd_score, cit.class_id, ";
		$want_col .= "tit.partici_num,tit.status,tit.sd_score, cit.groupid as class_id, ";
		$want_col .= "tqt.tested_id, qt.answer, tqt.question_type, tqt.score AS score_weight, ";
		$want_col .= "tqt.ave_score AS item_ave, ast.sd_score AS personal_sd ";

		//
//		$condition = " WHERE st.student_id = cst.student_id AND cst.class_student_id = stt.class_student_id ";
		$condition = " WHERE ctt.uid = tt.uid AND st.uid = cst.uid AND cst.class_student_id = stt.class_student_id ";
		$condition .= " AND tqt.tested_id = ast.tested_id AND stt.test_id = tqt.test_id ";
		$condition .= "AND cst.class_student_id = ast.class_student_id AND cst.class_student_id = '".$this->escapeSqlString($class_student_id);
		$condition .= "' AND qt.question_id = tqt.question_type";

//		$condition .= " AND tt.teacher_id = cit.teacher_id AND ";
//		$condition .= " cit.class_id = tit.class_id AND ";
//		$condition .= " cst.class_id = cit.class_id";
		$condition .= " AND ctt.groupid = cit.groupid AND ";

		$condition .= " cit.groupid = tit.groupid AND ";
		$condition .= " cst.groupid = cit.groupid";

		$condition .= " AND tit.test_id = tqt.test_id ";
		$condition .= " AND stt.test_id = '".$this->escapeSqlString($test_id);
//		$condition .= "' AND cst.student_id = '".$this->escapeSqlString($student_id)."' ORDER BY student_id, question_order";
		$condition .= "' AND cst.uid = '".$this->escapeSqlString($student_id)."' ORDER BY st.uid, question_order";

		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
}

class CAnalyzeTestQueAccess extends CTblAccess {
	//ʬѥǡ饹
//	var $answered_item_arr;
//	var $answered_txt_arr;
	var $test_info_arr;
	
	function CAnalyzeTestQueAccess () {
		$this->CTblAccess ("NOTSET");
	}
	
//	function setAnsweredItemArr ($conn, $qid) {
	function getAnsweredItemArr ($conn, $qid) {
		//̤ƥ
		if ($qid=="" || !is_numeric($qid)) return false;
		$this->tbl_name = TEST_QUE_TBL." AS tqt, ".ANSWERED_ITEM_TBL." AS ait";
		$want_col = "ait.answered_item, ait.class_student_id";
		$condition = " WHERE ait.tested_id = tqt.tested_id";
		$condition .= " AND tqt.question_type = '".$this->escapeSqlString($qid)."'";		
		$condition .=" ORDER BY ait.tested_id, ait.class_student_id";
/*		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) return false;
		$this->answered_item_arr = $result;
		return true;*/
		return $this->getList($want_col, $condition, $conn);
	}
/*	function getAnsweredItemArr () {
		return $this->answered_item_arr;
	}*/

	function getAnsweredTxtArr ($conn, $qid) {	
//	function setAnsweredTxtArr ($conn, $qid) {
		//̤ƥ
		if ($qid=="" || !is_numeric($qid)) return false;
		$this->tbl_name = TEST_QUE_TBL." AS tqt, ".ANSWERED_TXT_TBL." AS att";
		$want_col = "att.answered_txt, att.class_student_id";
		$condition = " WHERE att.tested_id = tqt.tested_id";
		$condition .= " AND tqt.question_type = '".$this->escapeSqlString($qid)."'";
		$condition .= " ORDER BY att.class_student_id";
/*		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) return false;
		$this->answered_txt_arr = $result;
		return true;*/
		return $this->getList($want_col, $condition, $conn);
	}
/*	function getAnsweredTxtArr () {
		return $this->answered_txt_arr;
	}*/
	
	function getTestInfoArr ($conn, $qid) {
	//䤬ꤵ줿ƥȤΰ
		if ($qid=="" || !is_numeric($qid)) return false;
//		$this->tbl_name = TEA_TBL." AS tt, ".CLASS_TBL." AS ct, ".TEST_INF_TBL." AS tit";
//ForXoops
		$this->tbl_name = USER_TBL." AS ut, ".CLASS_TEA_TBL." AS ctt, ".CLASS_TBL." AS ct, ".TEST_INF_TBL." AS tit, ";
		$this->tbl_name .= QUES_TBL." AS qtbl, ".TEST_QUE_TBL." AS tqt ";
		//ɬץեɤΤƤ
//		$want_col = "tt.teacher_id, tt.teacher_nam, ct.class_id, ct.class_nam, tit.test_nam";
		$want_col = "ut.uid as teacher_id, ut.uname AS teacher_nam, ct.groupid AS class_id, ct.name as class_nam, tit.test_nam, ";
		$want_col .= "qtbl.exp_dif, qtbl.real_dif, qtbl.level, qtbl.content, qtbl.answer,";
		$want_col .= "tit.test_id, tit.test_date, tit.exp_score, tit.partici_num, tit.duration ";
		
		$condition = " WHERE tit.status = 2 AND ";
		//ơλΤΤΤߤ
//		$condition .= " tit.class_id = ct.class_id AND ctt.teacher_id = tit.teacher_id AND";
		$condition .= " tit.groupid = ct.groupid AND ctt.groupid = tit.groupid AND ctt.uid=ut.uid AND ";
		$condition .= " tit.test_id =tqt.test_id AND qtbl.question_id = tqt.question_type AND qtbl.question_id = '".$this->escapeSqlString($qid)."'";
		return $this->getList($want_col, $condition, $conn);
	}
	
}

class CDownDataAccess extends CTblAccess {
	//XMLɤΥǡ򸡺
	function CDownDataAccess () {
		$this->CTblAccess ("NOTSET");
	}
	
	function getDownData ($conn) {
		$this->tbl_name = TXT_TBL." AS tt LEFT JOIN ".QUES_TBL." AS qt ";
		$this->tbl_name .= "ON tt.text_id = qt.text_id ";
		$this->tbl_name .= "LEFT JOIN ".ITEM_TBL;
		$this->tbl_name .=" AS it ON qt.question_id = it.question_id ";
		$this->tbl_name .= "LEFT JOIN ".KEY_WORD_TBL;
		$this->tbl_name .=" AS kt ON qt.question_id = kt.question_id ";
		
		$want_col = "tt.text_id, tt.text_title, tt.exp_dif AS te_dif, tt.real_dif As tr_dif, ";
		$want_col .= "tt.level AS t_level, tt.comment AS t_comment, tt.department_id, tt.content AS t_content, qt.question_id, ";
		$want_col .= "qt.exp_dif AS qe_dif, qt.real_dif AS qr_dif, qt.level AS q_level,";
		$want_col .= "qt.content AS q_content, qt.comment AS q_comment, ";
		$want_col .= "qt.answer, qt.example, qt.rep_key, qt.max_length, ";
		$want_col .= "qt.max_words, it.item_order, it.item_txt, it.is_right, ";
		$want_col .= "it.comment AS i_comment, kt.key_word_txt, ";
		$want_col .= "kt.score_weight, kt.comment AS k_comment";
		$condition = " ORDER BY tt.text_id, qt.question_id";
		return $this->getList($want_col, $condition, $conn);
	}
}
?>